#!/usr/bin/env python
#
#    Copyright (C) 2003-2004  James Tauber
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#

"""
This script converts the files in the static directory to .ldv bundles
in the Leonardo File System.
"""

# based on Min Sik Kim's earlier leonconv-04.py for converting 0.3 to 0.4 LFS.

import os
import sys
import shutil
from stat import ST_MODE, S_IXUSR, S_IXGRP, S_IXOTH

def usage():
    print 'Usage:', sys.argv[0], '<src_root> <dst_root>'
    sys.exit(0)


if len(sys.argv) != 3:
    usage()

src_root, dst_root = sys.argv[1], sys.argv[2]
if not os.path.exists(src_root):
    sys.stderr.write('Error: cannot find %s\n' % srcdir)
    sys.exit(1)


for root, dirs, files in os.walk(src_root):
    for name in files:
        src = os.path.join(root, name)
        ext = name.split(".")[-1]
        dst = os.path.join(root.replace(src_root, dst_root),
                           name + '.ldv',
                           '__content__.' + ext)
        dstdir = os.path.dirname(dst)
        if not os.path.exists(dstdir):
            os.makedirs(dstdir)
        shutil.copy2(src, dst)
        shutil.copystat(src, dstdir)
        os.chmod(dstdir, os.stat(dstdir)[ST_MODE] | S_IXUSR | S_IXGRP | S_IXOTH)
