#
#    Copyright (C) 2003-2005  James Tauber
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#


import sys

import request_response
import filesystem

from providers.manager import ProviderManager



class Leonardo:


    def __init__(self, configurator):
        
        self.configurator = configurator
        
        self.resource_manager = ProviderManager(self.configurator)
        
        
    def dispatch(self):

        request = request_response.Request(self.configurator)
    
        resource_id = request.relative_path
        
        if request.method == "GET":
            resource = self.resource_manager.get(resource_id, request, None)
        elif request.method == "POST":
            resource = self.resource_manager.post(resource_id, request, None)
        else:
            # @@@ need better error handling
            resource = None
    
        if request.not_modified(resource):        
            response = request_response.Response(status="304 Not Modified")
        else: 
            response = request_response.Response(resource)

        response.send(sys.stdout)
