#!/usr/bin/env python
#
#    Copyright (C) 2003-2004  James Tauber
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#
# Simulates Apache with the following directive:
#
# ScriptAlias / <LEONARDO_HOME>/cgi-bin/leonardo.py/
#
# Useful for getting going before you deploy on an actual webserver

import CGIHTTPServer
from BaseHTTPServer import HTTPServer

import sys
sys.path.append("cgi-bin")

def usage():
    print """
-h, --help : this help message
-n, --no-browser : don't start browser
-p <num>, --port=<num> : port to run on if not 8000
    """

import getopt
try:
    opts, args = getopt.getopt(sys.argv[1:], "hnp:", ["help", "no-browser", "port="])
except getopt.GetoptError:
    usage()
    sys.exit(2)
if args:
    usage()
    sys.exit(2)
start_browser = True
port = 8000
for o, a in opts:
    if o in ("-n", "--no-browser"):
        start_browser = False
    if o in ("-h", "--help"):
        usage()
        sys.exit()
    if o in ("-p", "--port"):
        port = int(a)

import os

class Handler(CGIHTTPServer.CGIHTTPRequestHandler):

    def do_POST(self):
        # for some reason the query string from the last request hangs
        # around without this.
        os.environ['QUERY_STRING'] = ""


        self.cgi_info = "/cgi-bin", "leonardo.py/" + self.path
        self.run_cgi()

    def do_GET(self):
        # for some reason the query string from the last request hangs
        # around without this.
        os.environ['QUERY_STRING'] = ""

        ims = self.headers.getheader('If-Modified-Since')
        if ims:
            os.environ['HTTP_IF_MODIFIED_SINCE'] = ims

        self.cgi_info = "/cgi-bin", "leonardo.py/" + self.path
        self.run_cgi()

server_address = ("", port)

httpd = HTTPServer(server_address, Handler)

if start_browser:
    import webbrowser
    webbrowser.open("http://localhost:%s/" % port, 1)

print "Serving HTTP on port", port, "..."
httpd.serve_forever()
